Program Euxinus_3DTUTER2_shadeddots;

uses crt,graph;

type
  SCRCORD = RECORD  { point on screen }
    X : INTEGER;
    Y : INTEGER;
  END;
  POINT = RECORD  { Point in 3d space }
    X : INTEGER;
    Y : INTEGER;
    Z : INTEGER;
  END;
  _3DOBJECT = RECORD
    degreinc : POINT;
    degre : POINT;
    numberofpoints : INTEGER;
    color : BYTE;
    shadedcolor : Array [1..2500] of BYTE;
    orginalcordinates : Array [1..2500] of POINT;
    rotatedcordinates : Array [1..2500] of POINT;
    screencordinates : Array [1..2500] of SCRCORD;
    objpos : POINT;
  end;

var obj : _3DOBJECT;
    sina,cosa : Array [0..360] of real;
    page : BYTE;

Procedure regularSphere;

VAR i,j,count : INTEGER;

Begin
  obj.color:=8;
  obj.degre.x:=0;
  obj.degre.y:=0;
  obj.degre.z:=0;
  obj.degreinc.x:=1;
  obj.degreinc.y:=1;
  obj.degreinc.z:=1;
  count:=0;
  FOR i:=-16 TO 16 DO FOR j:=1 TO 32 DO BEGIN
      inc(count);
      obj.orginalcordinates[count].x:=round (cos(I*180/32*pi/180)*cos(J*360/32*pi/180)*100);
      obj.orginalcordinates[count].y:=round (sin(I*180/32*pi/180)*100);
      obj.orginalcordinates[count].z:=round (cos(I*180/32*pi/180)*sin(J*360/32*pi/180)*100);
  END;
  obj.numberofpoints:=count;
end;

Procedure randomSphere;

VAR i,j,count : INTEGER;
    ran1,ran2 : LONGINT;

Begin
  obj.color:=8;
  obj.degre.x:=0;
  obj.degre.y:=0;
  obj.degre.z:=0;
  obj.degreinc.x:=1;
  obj.degreinc.y:=1;
  obj.degreinc.z:=1;
  randomize;
  FOR count:=1 to 1000 do BEGIN
      ran1:=random(360);
      ran2:=random(360);
      obj.orginalcordinates[count].x:=round (cos(ran1*pi/180)*cos(ran2*pi/180)*100);
      obj.orginalcordinates[count].y:=round (sin(ran1*pi/180)*100);
      obj.orginalcordinates[count].z:=round (cos(ran1*pi/180)*sin(ran2*pi/180)*100);
  END;
  obj.numberofpoints:=count;
end;


Procedure DottedCube;

VAR i,j : INTEGER;
    count : INTEGER;

Begin
  obj.color:=8;
  obj.degre.x:=0;
  obj.degre.y:=0;
  obj.degre.z:=0;
  obj.degreinc.x:=1;
  obj.degreinc.y:=1;
  obj.degreinc.z:=1;
  count:=0;
  { front }
  FOR i:=-5 TO 5 DO FOR j:=-5 TO 5 DO BEGIN
      inc(count);
      obj.orginalcordinates[count].x:=i*20;
      obj.orginalcordinates[count].y:=j*20;
      obj.orginalcordinates[count].z:=-100;
  END;
   { back }
  FOR i:=-5 TO 5 DO FOR j:=-5 TO 5 DO BEGIN
      inc(count);
      obj.orginalcordinates[count].x:=i*20;
      obj.orginalcordinates[count].y:=j*20;
      obj.orginalcordinates[count].z:=100;
  END;
  { top }
  FOR i:=-5 TO 5 DO FOR j:=-5 TO 5 DO BEGIN
      inc(count);
      obj.orginalcordinates[count].x:=i*20;
      obj.orginalcordinates[count].y:=-100;
      obj.orginalcordinates[count].z:=j*20;
  END;
  {bottom}
  FOR i:=-5 TO 5 DO FOR j:=-5 TO 5 DO BEGIN
      inc(count);
      obj.orginalcordinates[count].x:=i*20;
      obj.orginalcordinates[count].y:=100;
      obj.orginalcordinates[count].z:=j*20;
  END;
  { left }
  FOR i:=-5 TO 5 DO FOR j:=-5 TO 5 DO BEGIN
      inc(count);
      obj.orginalcordinates[count].x:= -100;
      obj.orginalcordinates[count].y:=i*20;
      obj.orginalcordinates[count].z:=j*20;
  END;
  { right }
  FOR i:=-5 TO 5 DO FOR j:=-5 TO 5 DO BEGIN
      inc(count);
      obj.orginalcordinates[count].x:= 100;
      obj.orginalcordinates[count].y:=i*20;
      obj.orginalcordinates[count].z:=j*20;
  END;
  obj.numberofpoints:=count;
end;

Procedure torus;

{ definiera en torus }

Var i,j : INTEGER;
    count : INTEGER;

BEGIN
  obj.color:=8;
  obj.degre.x:=0;
  obj.degre.y:=0;
  obj.degre.z:=0;
  obj.degreinc.x:=3;
  obj.degreinc.y:=3;
  obj.degreinc.z:=3;
  count:=0;
  for i:= 0 to 29 do for j:= 1 to 40 do begin
       inc(count);
       obj.orginalcordinates[count].x:=round(cos(i*360/29*pi/180)*(80+48*cos(j*360/40*pi/180)));
       obj.orginalcordinates[count].y:=round(48*sin(j*360/40*pi/180));
       obj.orginalcordinates[count].z:=round(sin(i*360/29*pi/180)*(80+48*cos(j*360/40*pi/180)));
   end;
  obj.numberofpoints:=count;
END;



Procedure XROUT;

Var i: INTEGER;

Begin
  for i:= 1 to obj.numberofpoints do begin
     { round off because floting point calulation sucks, and you relly
     doesn't lose very mush in accuracy}
    obj.rotatedcordinates[i].x := round(obj.objpos.x+obj.orginalcordinates[i].x);
    obj.rotatedcordinates[i].y := round(obj.objpos.y+obj.orginalcordinates[i].y*cosa[obj.degre.x]-obj.orginalcordinates[i].z*
  sina[obj.degre.x]);
    obj.rotatedcordinates[i].z := round(obj.objpos.z+obj.orginalcordinates[i].y*sina[obj.degre.x]+obj.orginalcordinates[i].z*
    cosa[obj.degre.x]);
  End;
End;

Procedure YROUT;

Var i: INTEGER;

Begin
  for i:= 1 to obj.numberofpoints do begin
    obj.rotatedcordinates[i].x := round(obj.objpos.x+obj.orginalcordinates[i].x*cosa[obj.degre.y]+obj.orginalcordinates[i].z
    *sina[obj.degre.y]);
    obj.rotatedcordinates[i].y := round(obj.objpos.y+obj.orginalcordinates[i].y);
    obj.rotatedcordinates[i].z := round(obj.objpos.z-obj.orginalcordinates[i].x*sina[obj.degre.y]+obj.orginalcordinates[i].z
    *cosa[obj.degre.y]);
  End;
End;

Procedure ZROUT;

Var i : INTEGER;

Begin
  for i:= 1 to obj.numberofpoints do begin
    obj.rotatedcordinates[i].x :=round( obj.objpos.x+obj.orginalcordinates[i].x*cosa[obj.degre.z]-obj.orginalcordinates[i].y
    *sina[obj.degre.z]);
    obj.rotatedcordinates[i].y :=round( obj.objpos.y+obj.orginalcordinates[i].x*sina[obj.degre.z]+obj.orginalcordinates[i].y
    *cosa[obj.degre.z]);
    obj.rotatedcordinates[i].z :=round( obj.objpos.z+obj.orginalcordinates[i].z);
  end;
end;

Procedure ZXYROUT;

Var a,b,c,d,e,f,g,h,j : REAL;
    i : INTEGER;


Begin
  a:=cosa[obj.degre.y]*cosa[obj.degre.z];
  b:=cosa[obj.degre.y]*sina[obj.degre.z];
  c:=-sina[obj.degre.y];
  d:=sina[obj.degre.x]*sina[obj.degre.y]*cosa[obj.degre.z]-cosa[obj.degre.x]*sina[obj.degre.z];
  e:=sina[obj.degre.x]*sina[obj.degre.y]*sina[obj.degre.z]+cosa[obj.degre.x]*cosa[obj.degre.z];
  f:=sina[obj.degre.x]*cosa[obj.degre.y];
  g:=cosa[obj.degre.x]*sina[obj.degre.y]*cosa[obj.degre.z]+sina[obj.degre.x]*sina[obj.degre.z];
  h:=cosa[obj.degre.x]*sina[obj.degre.y]*sina[obj.degre.z]-sina[obj.degre.x]*cosa[obj.degre.z];
  j:=cosa[obj.degre.x]*cosa[obj.degre.y];
  for i:= 1 to obj.numberofpoints do begin
    obj.rotatedcordinates[i].x :=round( obj.objpos.x+obj.orginalcordinates[i].x*a+obj.orginalcordinates[i].y*b
    +obj.orginalcordinates[i].z*c);
    obj.rotatedcordinates[i].y :=round( obj.objpos.y+obj.orginalcordinates[i].x*d+obj.orginalcordinates[i].y*e
    +obj.orginalcordinates[i].z*f);
    obj.rotatedcordinates[i].z :=round( obj.objpos.z+obj.orginalcordinates[i].x*g+obj.orginalcordinates[i].y*h
    +obj.orginalcordinates[i].z*j);
  end;
end;

procedure  uppgradeobject;

begin
  inc(obj.degre.x,obj.degreinc.x);
  inc(obj.degre.y,obj.degreinc.y);
  inc(obj.degre.z,obj.degreinc.z);
  if obj.degre.x<0 then inc(obj.degre.x,360);
  if obj.degre.x>360 then dec(obj.degre.x,360);
  if obj.degre.y<0 then inc(obj.degre.y,360);
  if obj.degre.y>360 then dec(obj.degre.y,360);
  if obj.degre.z<0 then inc(obj.degre.z,360);
  if obj.degre.z>360 then dec(obj.degre.z,360);
end;

Procedure rotateobjects;

begin
  zxyrout;
end;

procedure shade;

var i : INTEGER;

begin
  for i:= 1 to obj.numberofpoints do begin
    obj.shadedcolor[i]:=round(obj.color+((obj.rotatedcordinates[i].z-obj.objpos.z)/20));
  end;
end;


procedure perspective;

var i : INTEGER;

begin
  for i:= 1 to obj.numberofpoints do begin
    obj.screencordinates[i].x:=320+round(longint(obj.rotatedcordinates[i].x)*500/obj.rotatedcordinates[i].z);
    obj.screencordinates[i].y:=175+round(longint(obj.rotatedcordinates[i].y)*500/obj.rotatedcordinates[i].z);
  end;
end;

procedure putdots;

var i : INTEGER;

begin
  setvisualpage(page);
  page:=page xor 3;
  setactivepage(page);
  clearviewport;
  for i:=1 to obj.numberofpoints do begin
     putpixel(obj.screencordinates[i].x,obj.screencordinates[i].y,obj.shadedcolor[i]);
  end;
end;

procedure init;

var gd,gm : INTEGER;
    i : INTEGER;

begin
  gd:=vga;
  gm:=vgamed;          { graphics mode 640*350 pixels }
  initgraph(gd,gm,'c:\bp\bgi'{your bgi directory});
  for i:=0 to 360 do begin
    sina[i]:=sin(i*pi/180{*/180 converts it to radians which the computer
     calculed in don't think more about this});
    cosa[i]:=cos(i*pi/180);
  end;
  page:=2;
  obj.objpos.x:=0;
  obj.objpos.y:=0;
  obj.objpos.z:=350;
  torus;
end;

Procedure initcolors;

begin
  setrgbpalette(1,63,0,4);
  setrgbpalette(2,59,0,9);
  setrgbpalette(3,55,0,13);
  setrgbpalette(4,51,0,17);
  setrgbpalette(5,47,0,21);
  setrgbpalette(20,42,0,25);
  setrgbpalette(7,38,0,30);
  setrgbpalette(56,34,0,34);
  setrgbpalette(57,30,0,38);
  setrgbpalette(58,25,0,42);
  setrgbpalette(59,21,0,47);
  setrgbpalette(60,17,0,51);
  setrgbpalette(61,13,0,55);
  setrgbpalette(62,9,0,59);
  setrgbpalette(63,4,0,63);
end;

procedure Close;

begin
  closegraph;
end;

begin
 init;
 initcolors;
 repeat
   uppgradeobject;
   rotateobjects;
   perspective;
   shade;
   putdots;
 until keypressed;
 close;
end.