/* @(#)dither.h 1.5   8/26/96 */

/******************************************************************************
* Threedom: a 3D polygon renderer                                             *
* (C) Copyright 1996 by Philip Stephens                                       *
* (C) Copyright 1996 by the IBM Corporation                                   *
* All Rights Reserved                                                         *
*                                                                             *
* Permission to use, copy, modify, and distribute this software and its       *
* documentation without fee for any non-commerical purpose is hereby granted, *
* provided that the above copyright notice appears on all copies and that     *
* both that copyright notice and this permission notice appear in all         *
* supporting documentation.                                                   *
*                                                                             *
* NO REPRESENTATIONS ARE MADE ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY  *
* PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.       *
* NEITHER PHILIP STEPHENS OR IBM SHALL BE LIABLE FOR ANY DAMAGES SUFFERED BY  *
* THE USE OF THIS SOFTWARE.                                                   *
******************************************************************************/

/*
 * Externally visible data structures.
 */
extern fbpixel dither[4][FB_MAPS][PIXEL_COLOURS];
extern fbpixel light[4][LIGHT_MAX + 1];

/*
 * Externally visible functions.
 */
extern void create_dither_arrays(void);
extern void render_polygon_row(int sy, fixed left_sx, fixed right_sx,
			       fixed left_one_on_tz, fixed right_one_on_tz,
			       fixed left_u_on_tz, fixed right_u_on_tz,
			       fixed left_v_on_tz, fixed right_v_on_tz,
			       pixel *image_ptr, int width_mask,
			       int height_mask, int column_shift,
			       int light_level);
